﻿using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.EvolutionTracking {
  [StorableClass]
  [Item("Fragment", "An object that stores a ")]
  public class Fragment : Item, IFragment {
    [Storable]
    private int newPos;
    public int NewPos { get { return newPos; } set { newPos = value; } }

    [Storable]
    private int oldPos;
    public int OldPos { get { return oldPos; } set { oldPos = value; } }

    [Storable]
    private object root;
    public object Root {
      get { return root; }
      set { root = value; }
    }

    protected Fragment(Fragment original, Cloner cloner)
      : base(original, cloner) {
      Root = original.Root;
      NewPos = original.NewPos;
      OldPos = original.OldPos;
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new Fragment(this, cloner);
    }
    public Fragment() { }
  }

  public class Fragment<T> : Fragment, IFragment<T> where T : class {
    public new T Root {
      get { return (T)base.Root; }
      set { base.Root = value; }
    }
  }
}
